<?php
$berogui_path = '/usr/local/www/berogui';
require("$berogui_path/includes/Helper/Helper.php");

require("/usr/fallback/beroConf.php");
$bc = new beroConf('root');

function doUpdate($reboot_required) {
	$retval = 0;
	system(
	 	  'export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/snap/bin:$PATH;'
		. "/bin/bash /usr/local/beroNet/bin/sbcvm-update $reboot_required >/dev/null",
	$retval);
	return $retval == 0;
}

##### FORCE UPDATE AFTER AUTO FAILED OR TO FIX A MAJOR ISSUE ######
if (isset($_POST['force-update']) && $_POST['force-update']) {
	require("$berogui_path/misc/database.php");
	$ba = new beroAri();

	require_once("$berogui_path/includes/lang.php");
	if (Helper::getActivateOption() != '0') {
		header('Content-type: application/json');
		die(json_encode(array('error' => SBCVM_UPDATE_FAILED_ACTIVATE_NOTIF)));
	}
	else if (Helper::getTotalCalls() != '0') {
		header('Content-type: application/json');
		die(json_encode(array('error' => SBCVM_UPDATE_FAILED_ACTCALLS_NOTIF)));
	}

	if (!doUpdate('0')) {
		die(header("HTTP/1.0 500 Internal Server Error"));
	}
	foreach (array('sbcvmupdate-notif', 'has-major-issue', 'sbcvm-has-update') as $key) {
		$bc->delete('root', $key);
	}
	header('Content-type: application/json');
	die(json_encode(array('success' => UPDATE_TOOL_SUCCESSFUL)));
}

##### MANUAL UPDATE #####
/* [CHECKING GET] */
unset($_GET);

/* [CHECKING POST] */
$exec_ajax = 1;
$invalid = array();

$reboot_required = Helper::sanitizePost($_POST['sbcvmupdate-reboot'], 'bool', $exec_ajax, $invalid);
unset($_POST);

$data = array(
	'sbcvmupdate-mode'	=> 'manual',
	'sbcvmupdate-reboot'	=> $reboot_required === true ? 1 : 0,
	'sbcvmupdate-shownotif'	=> '1',
);

/* [EXEC AJAX] */
if (!$exec_ajax) {
	die(header("HTTP/1.0 400 Invalid data: sbcvmupdate-reboot is not a boolean"));
}

// clean cron directories
if (!Helper::cleanCronDirectories('sbcvm-update', array('daily', 'weekly', 'monthly'))) {
	die(header("HTTP/1.0 500 Internal Server Error"));
}

if (!doUpdate($reboot_required === true ? '1' : '0')) {
	die(header("HTTP/1.0 500 Internal Server Error"));
}

// save data into database
foreach ($data as $key => $value) {
	$bc->set('root', $key, $value);
}
// clean database
foreach (array('has-major-issue', 'sbcvm-has-update') as $key) {
	$bc-delete('root', $key);
}

// return
if ($reboot_required == true && Helper::isRebootRequired()) {
	echo '1';
}
else {
	echo '0';
}
?>
